/*
 * Crystal_Grid - Tim Tyler 1998-1999.
 */

   import java.awt.*;
   import java.awt.image.ImageObserver;
   import java.awt.event.*;
   import java.applet.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Random;
   import java.util.Date;
   import java.io.*;
   import java.lang.Object;

/* To do:
 * ======
 *
 * Add a "low number of bits"
 * live/dead array - to postpone cache thrashing...?
 *
 */

   public class Crystal_Grid extends Object {
      final static int QBERT      = 0;
      final static int MARGOLUS   = 1;
      final static int SOD        = 2;
      final static int WOLF       = 3;
      final static int TRIUMPHANT = 4;
   
      static int max_non_linearity;
   
      static int local_history_index;
      static int[][] in_grid;
      static int[][] out_grid;
      static int[][] tmp_grid;
      static int[][] help_grid;
   
      static int[][] grid_colour;
   
      static int[][] LUT_Table;
   
      static int[] bin256;
      static int[] sort256;
   
   
      // static Crystal_LUT[] LUT;
   
      static int poly8_x[] = new int[8];
      static int poly8_y[] = new int[8];
   
      static int poly6_x[] = new int[6];
      static int poly6_y[] = new int[6];
   
      static int poly4_x[] = new int[4];
      static int poly4_y[] = new int[4];
   
      static int poly3_x[] = new int[3];
      static int poly3_y[] = new int[3];
   
      final static int number_Crystal_LUT   = 16; // a power of two, please...
      final static int number_Crystal_LUTmo = number_Crystal_LUT - 1;
   
      static int maxstates;
      static int maxstatesmo;
      static int maxstatesmt;
   
      static int mask_value;
      static int BPC_value;
   
      static Crystal_Canvas random_canvas;
   
      static int mutation_rate = 0;
      static int radiation_rate = 0;
   
      static int any_selection = 0;
   
      static int rnd_frame;
      static int coverage_counter;
   
      static int invert_edges = 1;
   
      static int mouse_pressed = 0;
   
      static int a_atgrid = 0;
   
      static int sparse = 1;
   
      static int reproduction_delay_min = 16;
      static int reproduction_delay_max = 48;
   
      static int reverse = 0;
      static int direction = 1;
   
      static int newborn;
      static int generation;
   
      // static int frame;
   
      static int from_cell;
      static int from_cell1;
   
      static int current_direction;
   
      //int edge_death;
   
      static boolean RepaintAll = true;
   
      static Graphics graphics_handle;
   
      // static int ss_output;
      static int ss_north;
      static int ss_west;
      static int ss_centre;
      static int ss_east;
      static int ss_south;
      static int ss_input;
   
      static int next_result;
      static int last_result;
   
      static int next_ss;
      static int last_ss;
   
      static int cell_s;
      static int cell_n;
      static int cell_e;
      static int cell_w;
      static int cell_se;
      static int cell_ne;
      static int cell_sw;
      static int cell_nw;
      static int cell_c;
      static int cell_future;
   
      static int from_dir;
   
      static int last_temp;
      static int temp_x;
      static int temp_y;
   
      static int temp;
      static int temp2;
      static int temp3;
      static int temp4;
   
      static int tempA;
      static int temp2A;
      static int temp3A;
      static int temp4A;
   
      static int temp_delay;
   
      final static int snake_bg_colour = 0x00;
      final static int snake_eye_colour = 0x17F; // eyes
      final static int wall_colour = 0x1DA;
   
      static int oldcolour;
      static int last_colour;
   
      static int colour;
      static int default_colour;
      static int forward_colour;
      static int backward_colour;
   
      static int colourA;
      static int default_colourA;
      static int forward_colourA;
      static int backward_colourA;
   
      static int lastx = -1 ,lasty = -1;
   
      static int side = 100;
      static int inttemp;
   
      static Random rnd = new Random();
      static Random temp_rnd = new Random();
   
      static int[] snake_LUT1;
      static int[] snake_LUT2;
      static int[] snake_LUT3;
      static int[] snake_LUT4;
      static int[] snake_LUT5;
      static int[] snake_LUT6;
   
      static int smear_x = 0;
      static int smear_y = 0;
   
      static int hside;
      static int vside;
   
      static int gridsize = 4;
      static int cellsize;
   
      static int hexgridsize;
      static int hexcellsize;
   
      static int halfcellsize;
      static int halfgridsize;
   
      static int quartgridsize;
      static int quartcellsize;
   
      static int sharedgridsize;
      static int sharedcellsize;
   
      static int sharedhalfgridsize;
      static int sharedhalfcellsize;
   
      static int sharedquartgridsize;
      static int sharedquartcellsize;
   
      static int geometry = MARGOLUS;
   
      static int x_plot_gridsize;
      static int y_plot_gridsize;
   
      static int x_plot_cellsize;
      static int y_plot_cellsize;
   
      static int shared_y_plot_gridsize;
      static int shared_y_plot_cellsize;
   
      static int hsidemo;
      static int vsidemo;
   
      static int cx;
      static int cy;
   
      static int ncx;
      static int ncy;
   
      static int n0, s0, e0, w0;
      static int c0, c1;
      static int new_a0;
      static int new_a1;
      static int new_status;
      static int new_value;
      static int new_direction = 0;
   
      static int cell_number = 0;
   
      static int width;
      static int height;
   
      static int to_direction[];
      static int from_direction[];
      static int develop[];
      static int repro_direction[];
   
      static int appletsize = 512;
   
      // static int mask_value = 15;
   
      final static int MSGQ_SIZE = 32;
      final static int MONQ_SIZE = 512; // expands...
      final static int EDGELIST_SIZE = 1024; // !
   
      // OK, get that chunder-bucket ready ;-)
   
   
      final static int mask_act  = 0x0F;
      final static int mask_dev  = 0x70;
      final static int mask_devx = 0xF0;
   
      final static int DEAD      = 0x00;
      final static int WALL      = 0x7F;
   
      final static int END_TOP   = 1;
      final static int DATA1     = 2;
      final static int DATA2     = 3;
      final static int END_BOT   = 4;
   
      final static int CELL_SE_E_C    = 0x01;
      final static int CELL_W_SW_C    = 0x02;
      final static int CELL_NE_NW_C   = 0x03;
      final static int CELL_SE_E      = 0x04;
      final static int CELL_W_SW      = 0x05;
      final static int CELL_NE_NW     = 0x06;
      final static int CELL_SE_SW     = 0x07;
      final static int CELL_W_NW      = 0x08;
      final static int CELL_NE_E      = 0x09;
      final static int CELL_SE_NW     = 0x0A;
      final static int CELL_W_E       = 0x0B;
      final static int CELL_NE_SW     = 0x0C;
   
      final static int DEV_SE_C       = 0x10;
      final static int DEV_W_C        = 0x20;
      final static int DEV_NE_C       = 0x30;
      final static int DEV_SE         = 0x40;
      final static int DEV_W          = 0x50;
      final static int DEV_NE         = 0x60;
      final static int DEV_HEAD       = 0x70;
   
      final static int NORTH_WEST = 1;
      final static int NORTH_EAST = 2;
      final static int SOUTH_WEST = 4;
      final static int SOUTH_EAST = 8;
      final static int EAST       = 16;
      final static int WEST       = 32;
   
   
      // start types
   
   
   // colours...
      final static int COLOUR_MAX     = 512;
   
      final static int CONTROL_WIDTH  = 192;
      final static int CONTROL_HEIGHT = 32;
   
   // display type...
      final static int HEADSANDCELLS    = 0;
      final static int CELLTYPES        = 1;
      final static int DEVELOPMENT      = 2;
      final static int SNAKELIKE        = 3;
   
      // size selection?
      final static int _SIZE_UNK      = 0;
      final static int _SIZE_LARGE    = 1;
      final static int _SIZE_SMALL    = 2;
   
      final static int _TWIST_UNK     = 0;
      final static int _TWIST_HIGH    = 1;
      final static int _TWIST_LOW     = 2;
   
      final static int _EXTENT_UNK      = 0;
      final static int _EXTENT_LARGE    = 1;
      final static int _EXTENT_THIN     = 2;
      final static int _EXTENT_LONG     = 3;
      final static int _EXTENT_LONGTHIN = 4;
   
      final static int _PATTERN_UNK = 0;
      final static int _PATTERN_ON  = 1;
      final static int _PATTERN_OFF = 2;
      final static int _PATTERN_HAL = 3;
   
      final static int _MUT_OFF    =  -1;
      final static int _MUT_VLOW   =   1;
      final static int _MUT_LOW    =   2;
      final static int _MUT_QLOW   =   3;
      final static int _MUT_MEDIUM =   4;
      final static int _MUT_QHIGH  =   6;
      final static int _MUT_HIGH   =   8;
      final static int _MUT_VHIGH  =  10;
   
   
      final static int _FRAME_1   = 0;
      final static int _FRAME_2   = 1;
      final static int _FRAME_4   = 3;
      final static int _FRAME_8   = 7;
      final static int _FRAME_16  = 15;
      final static int _FRAME_32  = 31;
   
      // colours
      static Color WorldColour    = Color.black;
      static Color GridColour     = Color.black;
      // static Color CellColour     = Color.white;
      static Color PageColour     = new Color(0xF0,0xE8,0xFF);
   
      // static Color COLOUR_RIPE    = Color.red;
   
   
      static Color[] colours;
   
      static int display_type    = HEADSANDCELLS;
   
      // static int size_sel        = _SIZE_UNK;
      // static int twist_sel       = _TWIST_UNK;
      // static int extent_sel      = _EXTENT_UNK;
      // static int pattern_sel     = _PATTERN_UNK;
      // static int start_type      = 0;
   
      // static int initial_activity_type = INACTIVE; // RIPE! ;-)
   
      static int LUT_NUMBER = 16;
   
      public static void initialise(int resolutionx, int resolutiony) {
         int i,j;
      
        // LUT_Table = new int[16][LUT_NUMBER];
      
         mutation_rate = _MUT_OFF;
      
         set_size(resolutionx,resolutiony);
      
         colours = new Color[COLOUR_MAX];
      
         colours[0] = new Color(64,64,64);
      
      	// colours[1] = new Color(255,255,255);
      
         for (int c = 1; c < COLOUR_MAX; c++) {
            colours[c] = new Color((c & 7) * 32,(c & 56) * 4,(c & 448) / 2);
         }
      
         bin256 = new int[256];
         sort256 = new int[256];
      
      
         develop = new int[16];
         develop[1] = DEV_SE_C;
         develop[2] = DEV_W_C;
         develop[3] = DEV_NE_C;
         develop[4] = DEV_SE;
         develop[5] = DEV_W;
         develop[6] = DEV_NE;
         develop[7] = DEV_SE;
         develop[8] = DEV_W;
         develop[9] = DEV_NE;
         develop[10] = DEV_SE;
         develop[11] = DEV_W;
         develop[12] = DEV_NE;
      }
   
   
      public static void setupnewcells() {
         int x,y;
      
         for (x = 0; x < hside; x++) {
            for (y = 0; y < vside; y++) {
               in_grid[x][y] = 0;
               out_grid[x][y] = 0;
            }
         }
      }
   
   
      public static void set_size(int h, int v) {
         hside = h;
         vside = v;
      
         hsidemo = h - 1;
         vsidemo = v - 1;
      
         setGridSize(appletsize / h);
      
         // null old refs? no.
         in_grid = new int[h][v];
         out_grid = new int[h][v];
         help_grid = new int[h + 1][v + 1];
      
         grid_colour = new int[h][v];
      
         // tell browser!?? - or don't tell anyone...?
      
         setupnewcells();
      
         resetGrid();
      }
   
   
      public static void setPlotGridSize(int h, int v, int n) {
         x_plot_gridsize = h / n;
         y_plot_gridsize = v / n;
      
         x_plot_cellsize = x_plot_gridsize - 1;
         y_plot_cellsize = y_plot_gridsize - 1;
      
         if (x_plot_cellsize < 3) 
            x_plot_cellsize++;
      
         if (y_plot_cellsize < 3) 
            y_plot_cellsize++;
      
         if (isHexagonal() != 0) {
            shared_y_plot_gridsize = (y_plot_gridsize * 3) >>> 2;
            shared_y_plot_cellsize = ((y_plot_gridsize * 3) >>> 2) - 1;
         }
         else
         {
            shared_y_plot_gridsize = y_plot_gridsize;
            shared_y_plot_cellsize = y_plot_cellsize;
         }
      }
   
   
      public static void setGridSize(int s) {
         gridsize = s;
         halfgridsize = gridsize >> 1;
         quartgridsize = gridsize >> 2;
         hexgridsize = halfgridsize + quartgridsize;
      
         cellsize = gridsize - 1;
         halfcellsize = halfgridsize - 1;
         quartcellsize = quartgridsize - 1;
         hexcellsize = hexgridsize - 1;
      
         if (isHexagonal() != 0) {
            sharedgridsize = hexgridsize;
            sharedcellsize = hexcellsize;
         
            sharedhalfgridsize = hexgridsize >>> 1;
            sharedhalfcellsize = (hexgridsize >>> 1) - 1;
         
            sharedquartgridsize = hexgridsize >>> 2;
            sharedquartcellsize = (hexgridsize >>> 2) - 1;
         }
         else
         {
            sharedgridsize = gridsize;
            sharedcellsize = cellsize;
         
            sharedhalfgridsize = halfgridsize;
            sharedhalfcellsize = halfcellsize;
         
            sharedquartgridsize = quartgridsize;
            sharedquartcellsize = quartcellsize;
         }
      
         if (gridsize < 3)
            cellsize = gridsize;
      
         if (halfgridsize < 3)
            halfcellsize++;
      
         if (sharedgridsize < 3)
            sharedcellsize = sharedgridsize;
      
         if (sharedhalfgridsize < 3)
            sharedhalfcellsize++;
      
         if (halfgridsize < 1)
            halfgridsize = 1;
      
         if (gridsize < 1)
            gridsize = 1;
      
         width = hside * gridsize;
         height = vside * gridsize;
      }
   
   
      public static void resetGrid() {
         blankGrid();
      
         RepaintAll = true;
      }
   
   
      public static void setGrid() {
         for (cx = hside; cx-- > 0; ) {
            for (cy = vside; cy-- > 0; ) {
               in_grid[cx][cy] |= 0xFF;
            }
         }
      
         RepaintAll = true;
      }
   
   
     // don't call this...
      public static void blankGrid() {
         for (cx = hside; cx-- > 0; ) {
            for (cy = vside; cy-- > 0; ) {
               in_grid[cx][cy] &= 0xffffff00; // freeze, rnd, Crystal_ blanked out...
            }
         }
      }
   
   
      final static public void calculate_grid() {
         if ((hside == 1) || (vside == 1)) {
            trivialCopy();
         }
         else
         {
         
            cx = 0;
            for (cy = vside; cy-- > 0; ) {
               process_one_edge_cell(); // ??
            }
         
            cx = hsidemo;
            for (cy = vside; cy-- > 0; ) {
               process_one_edge_cell();
            }
         
            cy = 0;
            for (cx = hsidemo; cx-- > 1; ) {
               process_one_edge_cell(); // ??
            }
         
            cy = vsidemo;
            for (cx = hsidemo; cx-- > 1; ) {
               process_one_edge_cell(); // ??
            }
         
            for (cy = vsidemo; cy-- > 1; ) {
               for (cx = hsidemo; cx-- > 1; ) {
                  cell_w  = in_grid[cx - 1][cy    ];
                  cell_e  = in_grid[cx + 1][cy    ];
                  cell_n = in_grid[cx     ][cy - 1];
                  cell_s = in_grid[cx     ][cy + 1];
               
                  if ((cell_w | cell_e | cell_s | cell_n) == DEAD) {
                     if (out_grid[cx    ][cy    ] != DEAD) {
                        out_grid[cx    ][cy    ] = DEAD;
                     }
                  } 
                  else
                  {
                     cell_c  = in_grid[cx    ][cy    ];
                  
                     cell_process();
                  }
               }
            }
         }
      
         do_any_mutation();
         do_any_radiation();
      }
   
   
      // the performance of this code can be improved...
      final static void process_one_edge_cell() {
         cell_w = safeRead(cx - 1,cy    );
         cell_e = safeRead(cx + 1,cy    );
         cell_n = safeRead(cx    ,cy - 1);
         cell_s = safeRead(cx    ,cy + 1);
      
         if ((cell_w | cell_e | cell_s | cell_n) == DEAD) {
            if (out_grid[cx    ][cy    ] != DEAD) {
               out_grid[cx    ][cy    ] = DEAD;
            }
         } 
         else
         {
            cell_c  = in_grid[cx    ][cy    ];
         
            cell_process();
         }
      }
   
   
      final static void cell_process() {
         if (cell_c == WALL) {
            cell_future = WALL;
         }
         else
         {
            cell_future = DEAD;
            //if (cell_c << 16 != 0) { // not dead...
            temp = cell_c & 7;
            if ((cx & 1) == 0) {
               if (cell_n != DEAD) {
                  if ((cell_n & 7) == END_BOT) {
                     cell_future = cell_n - 0x100000;
                  }
                  else
                  {
                     cell_future = (cell_n & 0xff) | ((cell_c & 0xffffff00) - 0x100000);
                  }
               
                  if ((cell_n & 0xFFF00000) == 0) {
                     temp_rnd.setSeed(cx + generation);
                     temp_delay = (temp_rnd.nextInt() & 15) + reproduction_delay_min;
                     cell_future = cell_n | (temp_delay << 20);
                  }
               
                  if ((cell_c == DEAD) && ((cell_n & 7) != END_BOT)) {
                     cell_future = DEAD;
                  }
               
                  // kill partly unprotected cells...
                  if (((temp & 7) != END_BOT) && (temp != DEAD)) {
                     if (cell_s == DEAD) {
                        cell_future = DEAD;
                     }
                  }
               }
            }
            else
            {
               if (cell_s != DEAD) {
                  if ((cell_s & 7) == END_TOP) {
                     cell_future = cell_s - 0x100000;
                  }
                  else
                  {
                     cell_future = (cell_s & 0xff) | ((cell_c & 0xffffff00) - 0x100000);
                  }
               
                  if ((cell_s & 0xFFF00000) == 0) {
                     temp_delay = (temp_rnd.nextInt() & 15) + reproduction_delay_min;
                     cell_future = cell_s | (temp_delay << 20);
                  }
               
                  if ((cell_c == DEAD) && ((cell_s & 7) != END_TOP)) {
                     cell_future = DEAD;
                  }
               
                  // kill partly unprotected cells...
                  if (((temp & 7) != END_TOP) && (temp != DEAD)){
                     if (cell_n == DEAD) {
                        cell_future = DEAD;
                     }
                  }
               }
               else
               {
                  cell_future = DEAD;
               }
            }
         
            if (temp == DEAD) {
               if ((cell_s == DEAD) && (cell_n == DEAD)) {
                  if ((cell_e != DEAD) & ((cell_e & 0xfff00000) == 0)) {
                     temp_delay = (temp_rnd.nextInt() & 15) + reproduction_delay_min;
                     cell_future = cell_e | (temp_delay << 20);
                  }
               
                  if ((cell_w != DEAD) & ((cell_w & 0xfff00000) == 0)) {
                     temp_rnd.setSeed(cx+generation);
                     temp_delay = (temp_rnd.nextInt() & 15) + reproduction_delay_min;
                     cell_future = cell_w | (temp_delay << 20);
                  }
               }
            }
         }
      
      	// cell death...
         out_grid[cx][cy] = cell_future;
      }
   
   
      final static void trivialCopy() {
         if ((hside == 1) & (vside == 1)) {
            out_grid[0][0] = in_grid[0][0];
         }
         else
         {
            if (vside == 1) {
               for (cx = 0; cx < hside; cx++) {
                  out_grid[cx][0] = in_grid[cx][0];
               }
            }
            else
            {
               if (hside == 1) {
                  for (cy = 0; cy < vside; cy++) {
                     out_grid[0][cy] = in_grid[0][cy];
                  }
               }
               else {
                  for (cx = 0; cx < hside; cx++) {
                     for (cy = 0; cy < vside; cy++) {
                        out_grid[cx][cy] = in_grid[cy][cy];
                     }
                  }
               }
            }
         }
      }
   
   
      final static void simpleCopy() {
         for (cx = 0; cx < hside; cx++) {
            for (cy = 0; cy < vside; cy++) {
               out_grid[cx][cy] = in_grid[cx][cy];
            }
         }
      }
   
   
   
      final static int safeRead(int x, int y) {
         if (x < 0) 
            return 0;
      
         if (x > hsidemo) 
            return 0;
      
         if (y < 0) 
            return 0;
      
         if (y > vsidemo) 
            return 0;
      
         return in_grid[x][y];
      }
   
   
      final static void swap_grids() {
         // swap them...
         tmp_grid = in_grid;
         in_grid = out_grid;
         out_grid = tmp_grid;
      }
   
   
      final static void do_any_mutation() {
      }
   
   
      final static void do_any_radiation() {      
      	 // radiation...
         if ((generation & 3) == 0) {
            if (radiation_rate != _MUT_OFF) {
               rnd_frame = rnd.nextInt();
            
               for (temp = ((radiation_rate * hside * vside) >>> 12); temp-- > 0; ) {
                  cx = (rnd_frame >>> 2) % hside;
                  cy = (rnd_frame >>> 12) % vside;
               
                  rnd_frame = rnd.nextInt(); // *need* new value due to loop...?
               
                  if (out_grid[cx][cy] != WALL) {
                     out_grid[cx][cy] = DEAD;
                  }
               }
            }
         }
      }
   
   
      final public static void completelyClearGid(Graphics g) {
         int width = hside * gridsize;
      
         graphics_handle.setColor(GridColour);
         graphics_handle.fillRect(0,0,width + 1,width + 1);
      }
   
   
   
      private static void redrawAllMargolus() {
         temp = in_grid[cx][cy];
      
         // colour = ((temp & 15) + (temp & 15) << 4);
         colour = temp & 7;
      
         temp2 = ((cx & 1) == 0) ? 0 : 2;
      
         switch (colour) {
            case 1: 
               colour = 508 | temp2;
            
               break;
         
            case 4:
               colour = 504 | temp2;
            
               break;
         
            case 2: 
               colour = 0x150 | temp2;
            
               break;
         
            case 3: 
               colour = 0x1a8 | temp2;
            
               break;
         }
      
         setUpColour();
      
         graphics_handle.fillRect(cx*gridsize, cy*gridsize, cellsize, cellsize);
      }
   
   
      private static void redrawMargolus() {
         temp = in_grid[cx][cy];
         temp2 = out_grid[cx][cy];
      
         if (temp != temp2) {
            colour = temp & 7;
         
            temp2 = ((cx & 1) == 0) ? 0 : 2;
         
            switch (colour) {
               case 1: 
                  colour = 508 | temp2;
               
                  break;
            
               case 4:
                  colour = 504 | temp2;
               
                  break;
            
               case 2: 
                  colour = 0x150 | temp2;
               
                  break;
            
               case 3: 
                  colour = 0x1a8 | temp2;
               
                  break;
            }
         
            // colour = ((temp & 15) + (temp & 15) << 4);
            setUpColour();
         
            graphics_handle.fillRect(cx*gridsize, cy*gridsize, cellsize, cellsize);
         }
      }
   
   
   
   
      private static void redrawAllTypes() {
         temp = in_grid[cx][cy];
      
         colour = temp & 7;
      
         temp2 = ((cx & 1) == 0) ? 0 : 2;
      
         switch (colour) {
            case 1: 
               colour = 508 | temp2;
            
               break;
         
            case 4:
               colour = 504 | temp2;
            
               break;
         
            case 3: 
            case 2: 
               colour = (temp >> 20 & 511) | temp2;
            
               break;
         }
      
         setUpColour();
      
         graphics_handle.fillRect(cx*gridsize, cy*gridsize, cellsize, cellsize);
      }
   
   
      private static void redrawTypes() {
         temp = in_grid[cx][cy];
         temp2 = out_grid[cx][cy];
      
         if (temp != temp2) {
            colour = temp & 7;
         
            temp2 = ((cx & 1) == 0) ? 0 : 2;
         
            switch (colour) {
               case 1: 
                  colour = 508 | temp2;
               
                  break;
            
               case 4:
                  colour = 504 | temp2;
               
                  break;
            
               case 3: 
               case 2: 
                  colour = (temp >> 20 & 511) | temp2;
               
                  break;
            }
         
            setUpColour();
         
            graphics_handle.fillRect(cx*gridsize, cy*gridsize, cellsize, cellsize);
         }
      }
   
   
      private static void setUpColour() {
         if (colour!= last_colour) {
            graphics_handle.setColor(colours[colour]);
            last_colour = colour;
         }
      }
   
   
      final public static void redraw_changed(Graphics g) {
         graphics_handle = g;
      
         last_colour = -1;
      
         if (RepaintAll || (Crystal.frame_frequency > 16)) { //  && (Crystal.busy == 0)) {
            graphics_handle.setColor(Color.black);
            graphics_handle.fillRect(0,0,9999,9999);
            switch (display_type) {
               case HEADSANDCELLS:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawAllMargolus();
                     }
                  }
               
                  break;
            
               case CELLTYPES:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawAllTypes();
                     }
                  }
               
                  break;
            }
         
            RepaintAll = false;
         }
         else
         {
            switch (display_type) {
               case HEADSANDCELLS:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawMargolus();
                     }
                  }
               
                  break;
            
               case CELLTYPES:
                  for (cx = hside; cx-- > 0; ) {
                     for (cy = vside; cy-- > 0; ) {
                        redrawTypes();
                     }
                  }
               
                  break;
            }
         }
      }
   
   
      final public static int getCoveragePercentage() {
         //if ((sparse) != 0) {
         //temp = coverage_counter; // last_living;
         /*
         } 
         else
         {
            temp = 0;
         
            for (cx = hside; cx-- > 0; ) {
               for (cy = vside; cy-- > 0; ) {
                  if ((in_grid[cx][cy].a0 & mask_a0_sta) > EDGE)
                     temp++;
               }
            }
         }
      */
      
         temp = coverage_counter * 101 / (hside * vside);
         if (temp > 99)
            temp = 100;
      
         return temp;
      }
   
   
      final public static void invertAll() {
         // for (cx = 0; cx < number_Crystal_LUT; cx++) {
         //    LUT[cx].invert();
         // }
      }
   
      final public static int isHexagonal() {
         if ((geometry == SOD) || (geometry == QBERT) || (geometry == TRIUMPHANT)) {
            return 1;
         }
      
         return 0;
      }	
   
      public static int getMaskValue() {
         mask_value = (1 << getBPCValue()) - 1;
      
         return mask_value;
      }
   
   
      public static int getBPCValue() {
         switch (Crystal_Grid.geometry) {
            case Crystal_Grid.WOLF:
               BPC_value = 1;
            
               break;
         
            case Crystal_Grid.QBERT:
            case Crystal_Grid.TRIUMPHANT:
               BPC_value = 3;
            
               break;
         
            case Crystal_Grid.MARGOLUS:
               BPC_value = 4;
            
               break;
            case Crystal_Grid.SOD:
               BPC_value = 6;
            
               break;
         }
      
         return BPC_value;
      }
   
      public static int randomCell() {
         do {
            temp = rnd.nextInt() & 7;
         } while ((temp & mask_act) >= 0x05);
      
         return temp;
      }
   
   }

